Program TARNDMap;
Uses STMR_LOW,STMR_MID,STMR_STR,ASMUtils;

{$I UPDATE.INC }

CONST

  MaxScenery = 200;

  BoxX       = 48;
  BoxY       = 14;

TYPE
 AttrStruc = Record
  h          :Byte;
  special    :Word;
  unknown    :Byte;
 end;

 TA_TNTHeader = Record
  IDversion          :LongInt;       { $00- }
  Width              :LongInt;       { $04- }
  Height             :LongInt;       { $08- }
  PTRmapdata         :LongInt;       { $0C- }
  PTRmapattr         :LongInt;       { $10- }
  PTRtilegfx         :LongInt;       { $14- }
  tiles              :LongInt;       { $18- }
  tileanims          :LongInt;       { $1C- }
  PTRtileanim        :LongInt;       { $20- }
  sealevel           :LongInt;       { $24- }
  PTRminimap         :LongInt;       { $28- }
  unknown1           :LongInt;       { $2C- }
  pad1,pad2,pad3,pad4:LongInt;
 end;

VAR
 BytesRead              :Word;
 IS             :Byte;

 Y                      :Byte;
 F                      :File;
 Cursor                 :Word;

 TNT                    :TA_TNTHeader;
 Attr                   :AttrStruc;

 fn                     :String;

 PrevScreen             :Pointer;

 Ch                     :Char;
 YPos,OldYPos           :Byte;
 TopPek                 :Word;
 Placed                 :LongInt;
 HitRatio               :Byte;

 Scenery                :Array[1..MaxScenery] of String[15];
 SceneryRND             :Array[1..MaxScenery] of Word;

Function St(const I :LongInt): String;
var
 s:      String[10];
begin
 Str(I,S);
 St:=S;
end;

Function Va(const s: string): longint;
var
 code:   Integer;
 vas:    Longint;
begin
 Val(s,vas,code);
 Va:=vas
end;

Function ZTS2String(VAR ZS): String; Assembler;
asm
 push ds
 les  di,ZS
 mov  bx,di
 xor  al,al
 repne scasb
 sub  di,bx
 dec  di
 mov  cx,di
 les  di,@result
 lds  si,ZS
 mov  al,cl
 stosb
 rep  movsb
 pop  ds
end;
(*
Procedure InfoScreen;
var
 TL        :^OTextList;
 OldScreen :Pointer;
begin
 ScreenStore(OldScreen);
 WindowBox2(4,Y+7,72,13,$78,$7F,$71,SinFrame,0,$4E,'Help',True);
 CentreC('Use the arrow keys '#24#25' to scroll up/down, then press ENTER.',Y+14+7,138);
 New(TL,Init(5,Y+1+7,70,11));
 TL^.SetupBuf(@InfoTXT,@InfoPTR,SizeOf(InfoTXT),SizeOf(InfoPTR) div 2);
 TL^.ShowAndScroll;
 Dispose(TL);
 ScreenRestore(OldScreen);
end;*)

Procedure LoadScenery;
var
 Y              :Byte;
 percentage     :Byte;
 loop           :Word;
 data           :Array[1..132] of Byte;

begin
 ScreenStore(PrevScreen);
 Y:=(SH div 2)-10;
 WindowBox2(6,Y,68,5,$78,$7F,$71,SinFrame,0,$4E,' Loading Scenery ... ',True);
 Seek(F,TNT.PTRTileAnim);
 for loop:=1 to TNT.TileAnims do
  begin
   BlockRead(F,data,SizeOf(Data),BytesRead);
   Scenery[loop]:=ZTS2String(data[5]);
   Percentage:=Trunc((100/TNT.TileAnims)*loop);
   ProgressBar(10,Y+2,SW-20,Trunc(100*(loop/TNT.TileAnims)));
  end;

 Placed:=0;
 WindowBox2(6,Y,68,5,$78,$7F,$71,SinFrame,0,$4E,' Scanning Scenery ... ',True);
 Seek(F,TNT.PTRMapAttr);
 for loop:=1 to TNT.Width*TNT.Height do
  begin
   BlockRead(F,attr,4,BytesRead);
   Percentage:=40;
   if attr.special<>$FFFF then
    begin
     Inc(SceneryRND[attr.special+1]);
     Inc(Placed);
    end;
   ProgressBar(10,Y+2,SW-20,Trunc(100*(loop/(TNT.Width*TNT.Height)) ) );
  end;
 ScreenRestore(PrevScreen);
end;

Procedure UpdateList1;
var
 Loop           :Byte;
 a              :Byte;
begin
 a:=1;
 for loop:=TopPek to TopPek+MinW(7,TNT.TileAnims-1) do
  begin
   WriteXY(BoxX+2,BoxY+a,PadRight_F(Scenery[loop],25,32));
   WriteXY(BoxX+20,BoxY+a,St(SceneryRND[loop]));
   Inc(a);
  end;
 DrawHAttr(BoxX+1,BoxY+YPos,28,31);
 CentreCode('~  # of scenery objects placed: ~'+St(Placed)+'  ',Y+10);

end;

Procedure W_SetValue;
var
 S              :String;
 oldval         :LongInt;
begin
 S:=Input(BoxX+20,BoxY+YPos,St(SceneryRND[TopPek+YPos-1]),'',4,-1,[#48..#57],True,IS);
 HideCursor;
 OldVal:=SceneryRND[TopPek+YPos-1];
 SceneryRND[TopPek+YPos-1]:=Va(S);
 Inc(placed,va(s)-OldVal);
 UpdateList1;
end;

FUNCTION Crc16(var buffer; size, seed: word): word; assembler;
ASM
    les     di, buffer
    mov     dx, size
    mov     ax, seed
    mov     si, 1021h
@next:
    xor     bl, bl
    mov     bh, es:[di]
    xor     ax, bx
    shl  ax, 1;    jnc  @noXor1;    xor  ax, si
@noXor1:
    shl  ax, 1;    jnc  @noXor2;    xor  ax, si
@noXor2:
    shl  ax, 1;    jnc  @noXor3;    xor  ax, si
@noXor3:
    shl  ax, 1;    jnc  @noXor4;    xor  ax, si
@noXor4:
    shl  ax, 1;    jnc  @noXor5;    xor  ax, si
@noXor5:
    shl  ax, 1;    jnc  @noXor6;    xor  ax, si
@noXor6:
    shl  ax, 1;    jnc  @noXor7;    xor  ax, si
@noXor7:
    shl  ax, 1;    jnc  @noXor8;    xor  ax, si
@noXor8:
    inc     di
    dec     dx
    jnz     @next
END;



Procedure SetSeed;
var
 S                      :String;
 loop                   :Byte;
begin
 ScreenStore(PrevScreen);
 WindowBox2(6,Y+13,38,5,$78,$7F,$71,SinFrame,0,$4E,' Enter SEED-PHRASE ',True);
 S:=Input(8,Y+15,'','',34,-1,[#32..#255],True,IS);
 HideCursor;
 Upper_P(S);
 RandSeed:=Crc16(S[1],Length(S),0);
 ScreenRestore(PrevScreen);
end;

Procedure DoRandomize;
var
 Loop           :Word;
 NewRND         :Word;
begin
 Placed:=0;
 for loop:=1 to TNT.TileAnims do
  begin
   newRND:=Random(Trunc((0.01*HitRatio)*( (TNT.Width*TNT.Height div TNT.TileAnims) div 8)));
   Inc(Placed,NewRND);
   SceneryRND[loop]:=NewRND;
  end;
 UpdateList1;
end;

Procedure Execute;
var
 PrevPOS        :LongInt;
 Loop           :LongInt;
 R1,R2          :LongInt;
 whichto        :Word;
 Bail           :Word;
begin
 ScreenStore(PrevScreen);

 WindowBox2(6,Y,68,5,$78,$7F,$71,SinFrame,0,$4E,' Erasing scenery ... ',True);
 Seek(F,TNT.PTRMapAttr);
 for loop:=1 to TNT.Width*TNT.Height do
  begin
   PrevPOS:=FilePos(F);
   BlockRead(F,attr,4,BytesRead);
   if attr.special<>$FFFF then
    begin
     attr.special:=$FFFF;
     Seek(F,PrevPOS);
     BlockWrite(f,attr,4,bytesread);
    end;
   ProgressBar(10,Y+2,SW-20,Trunc(100*(loop/(TNT.Width*TNT.Height)) ) );
  end;

 WindowBox2(6,Y,68,5,$78,$7F,$71,SinFrame,0,$4E,' Placing scenery ... ',True);
 for loop:=1 to Placed do
  begin
   R1:=Random(TNT.Width);
   R2:=Random(TNT.Height);
   Seek(F,TNT.PTRMapAttr+((R1+(R2*TNT.Width)))*4);
   PrevPOS:=FilePos(F);
   BlockRead(F,attr,4,BytesRead);
   Bail:=0;
   repeat
    Whichto:=Random(TNT.TileAnims)+1;
    Inc(BAIL);
   until (SceneryRND[WhichTo]>0) or (BAIL=1000);
   if BAIL<1000 then
    begin
     Seek(F,PrevPOS);
     attr.special:=WhichTo-1;
     BlockWrite(F,attr,4,BytesRead);
     Dec(SceneryRND[WhichTo]);
    end;
   ProgressBar(10,Y+2,SW-20,Trunc(100*(loop/placed)));
  end;
 ScreenRestore(PrevScreen);
end;

BEGIN
 fn:=ParamStr(1);
 Upper_P(fn);
 if NOT Exist(Fn) then
  begin
   WriteLn('  Error: .TNT file not found "',FN,'"');

   HALT(1);
  end;

 STMR_LOW.Init;
 Cursor:=GetCursor;
 HideCursor;
 SetBlink(FALSE);
 WindowBox(0,0,SW,SH,143,128,143,SinFrame,False);

 Y:=(SH div 2)-10;
 WindowBox2(6,Y,68,5,$78,$7F,$71,SinFrame,0,$4E,'Information',True);
 Centre('[ Total Annihilation Scenery Randomizer v0.1 ]',Y+2);

 Assign(F,fn);
 Reset(F,1);
 BlockRead(F,TNT,SizeOf(TA_TNTHeader));
  LoadScenery;

 WindowBox(2,Y+7,SW-4,5,128,143,143,SinFrame,False);
 CentreCode('~Map loaded: ~'+FN,Y+8);
 CentreCode('~# of different scenery objects available: ~'+St(TNT.TileAnims),Y+9);

 WindowBox(BoxX,BoxY,30,10,128,143,143,SinFrame,False);
 TopPek:=1;
 YPos:=1;

 WriteXYCode(10,Y+13+0,'~Press ~F1 ~to execute');
 WriteXYCode(10,Y+13+2,'~Press ~F5 ~to enter seed-phrase ');
 WriteXYCode(10,Y+13+4,'~Press ~F9 ~to randomize');
 WriteXYCode(10,Y+13+7,'~Press ~ESC ~to exit');

 HitRatio:=10;
 if Va(ParamStr(2))<>0 then HitRatio:=Va(ParamStr(2));
 if HitRatio>100 then HitRatio:=100;

 UpdateList1;

 REPEAT
  Ch:=ReadKey;
  if Ch=ENTER then W_SetValue;

  if Ch=#0 then
   begin
   Ch:=ReadKey;
   OldYPos:=YPos;

   if Ch=F5 then SetSeed;
   if Ch=F9 then DoRandomize;
   if Ch=F1 then
    begin
     Execute;
     Ch:=ESC;
    end;

   if Ch=DownKey then Inc(YPos);
   if Ch=UpKey then Dec(YPos);
   if Ch=LeftKey then if SceneryRND[TopPek+YPos-1]>0 then
    begin
     Dec(SceneryRND[TopPek+YPos-1]);
     Dec(Placed);
     UpdateList1;
    end;
   if Ch=RightKey then if SceneryRND[TopPek+YPos-1]<MinW(65535,TNT.Height*TNT.Width) then
    begin
     Inc(SceneryRND[TopPek+YPos-1]);
     Inc(Placed);
     UpdateList1;
    end;
   if YPos<>OldYPos then
    begin
     if YPos>MinW(TNT.TileAnims,8) then { Scroll down }
      begin
       Inc(TopPek);
       YPos:=MinW(TNT.TileAnims,8);
      end;
     if YPos=0 then { Scroll up }
      begin
       YPos:=1;
       Dec(TopPek);
     end;

     if TopPek+YPos>TNT.TileAnims then TopPek:=1+(TNT.TileAnims-MinW(TNT.TileAnims,8));
     if TopPek=0 then TopPek:=1;

     DrawHAttr(BoxX+1,BoxY+OldYPos,28,143);
     UpdateList1;
    end;
   end; { extended key }

 UNTIL Ch=ESC;

 Close(F);
 SetBlink(TRUE);
 ClrScr;
 SetCursor(Cursor);
 GotoXY(1,SH-2);
 WriteLn('Bye!');
END.
